import'reflect-metadata';import storage from'redux-persist/lib/storage/index.js';import {combineReducers}from'@reduxjs/toolkit';import autoMergeLevel2 from'redux-persist/lib/stateReconciler/autoMergeLevel2.js';import {createEpicMiddleware}from'redux-observable';import {createRouterReducer}from'@common-stack/remix-router-redux';import {persistReducer}from'redux-persist';import {REDUX_PERSIST_KEY}from'@common-stack/client-core';import {createReduxStore as createReduxStore$1}from'./base-redux-config.js';import {logger}from'../utils/index.js';import features from'../modules.js';import {rootEpic}from'./epic-config.js';const epicMiddlewareFunc = (apolloClient, services, container) => createEpicMiddleware({
    dependencies: {
        apolloClient,
        routes: features.getConfiguredRoutes(),
        services,
        container,
        logger,
        config: {
            loadRoot: false,
        }
    },
});
const persistConfig = {
    key: REDUX_PERSIST_KEY,
    storage,
    stateReconciler: autoMergeLevel2,
    transforms: features.reduxPersistStateTransformers,
    blacklist: ['router']
};
/**
 * Add any reducers required for this app dirctly in to
 * `combineReducers`
 */
const createReduxStore = (apolloClient, services, container) => {
    const reducers = {
        router: createRouterReducer({}),
        ...features.reducers,
    };
    let store;
    // @ts-ignore
    if (import.meta.hot && import.meta.hot.data && import.meta.hot.data.store) {
        // console.log('Restoring Redux store:', JSON.stringify(import.meta.hot.data.store.getState()));
        // @ts-ignore
        store = import.meta.hot.data.store;
        // replace the reducers always as we don't have ablity to find
        // new reducer added through our `modules`
        store.replaceReducer(persistReducer(persistConfig, combineReducers(reducers)));
    }
    else {
        let initialState = {};
        let middlewares = [];
        if (__CLIENT__ && typeof window !== 'undefined') {
            initialState = { ...window.__PRELOADED_STATE__ }; // #952 TODO we need cookie to have id_token for SSR to work properly
            delete window.__PRELOADED_STATE__; // Delete it once we have it stored in a variable
            // it doesn't work, since __remixRouter is not created yet.
            // middlewares = [createRouterMiddleware({ router: window.__remixRouter } as any)]; 
        }
        store = createReduxStore$1({
            scope: __CLIENT__ && typeof window !== 'undefined' ? 'browser' : 'server',
            isDebug: true,
            isDev: process.env.NODE_ENV === 'development',
            initialState,
            persistConfig,
            middleware: middlewares,
            epicMiddleware: epicMiddlewareFunc(apolloClient, services, container),
            rootEpic: rootEpic,
            reducers,
        });
    }
    if (container.isBound('ReduxStore')) {
        container
            .rebind('ReduxStore')
            .toDynamicValue(() => store)
            .inRequestScope();
    }
    else {
        container
            .bind('ReduxStore')
            .toDynamicValue(() => store)
            .inRequestScope();
    }
    return { store };
};export{createReduxStore,epicMiddlewareFunc,persistConfig};